Index: /branches/3040_VectorBasedGP/HeuristicLab.DiffSharp/HeuristicLab.DiffSharp.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.DiffSharp/HeuristicLab.DiffSharp.csproj	(revision 17759)
+++ /branches/3040_VectorBasedGP/HeuristicLab.DiffSharp/HeuristicLab.DiffSharp.csproj	(revision 17759)
@@ -0,0 +1,96 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="15.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.DiffSharp</RootNamespace>
+    <AssemblyName>HeuristicLab.DiffSharp</AssemblyName>
+    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <Deterministic>true</Deterministic>
+    <TargetFrameworkProfile />
+  </PropertyGroup>
+  <PropertyGroup>
+    <SatelliteResourceLanguages>en</SatelliteResourceLanguages>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>..\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AutoGenerateBindingRedirects>true</AutoGenerateBindingRedirects>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+    <Compile Include="Plugin.cs" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
+      <Project>{94186a6a-5176-4402-ae83-886557b53cca}</Project>
+      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <PackageReference Include="DiffSharp">
+      <Version>0.7.7</Version>
+    </PackageReference>
+    <PackageReference Include="FSharp.Core">
+      <Version>4.7.2</Version>
+      <PrivateAssets>all</PrivateAssets>
+    </PackageReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+  </PropertyGroup>
+  <PropertyGroup>
+    <PostBuildEvent>rm -d -r $(OutDir)cs
+rm -d -r $(OutDir)de
+rm -d -r $(OutDir)es
+rm -d -r $(OutDir)fr
+rm -d -r $(OutDir)it
+rm -d -r $(OutDir)ja
+rm -d -r $(OutDir)ko
+rm -d -r $(OutDir)pl
+rm -d -r $(OutDir)pt-BR
+rm -d -r $(OutDir)ru
+rm -d -r $(OutDir)tr
+rm -d -r $(OutDir)zh-Hans
+rm -d -r $(OutDir)zh-Hant</PostBuildEvent>
+  </PropertyGroup>
+</Project>
Index: /branches/3040_VectorBasedGP/HeuristicLab.DiffSharp/Plugin.cs.frame
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.DiffSharp/Plugin.cs.frame	(revision 17759)
+++ /branches/3040_VectorBasedGP/HeuristicLab.DiffSharp/Plugin.cs.frame	(revision 17759)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.DiffSharp {
+  [Plugin("HeuristicLab.DiffSharp", "HeuristicLab wrapper for DiffSharp nuget package.", "0.7.7.$WCREV$")]
+  [PluginFile("HeuristicLab.DiffSharp.dll", PluginFileType.Assembly)]
+  [PluginFile("DiffSharp.dll", PluginFileType.Assembly)]
+  [PluginFile("FSharp.Core.dll", PluginFileType.Assembly)]
+  [PluginFile("FSharp.Quotations.Evaluator.dll", PluginFileType.Assembly)]
+  public class Plugin : PluginBase {
+  }
+}
Index: /branches/3040_VectorBasedGP/HeuristicLab.DiffSharp/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.DiffSharp/Properties/AssemblyInfo.cs.frame	(revision 17759)
+++ /branches/3040_VectorBasedGP/HeuristicLab.DiffSharp/Properties/AssemblyInfo.cs.frame	(revision 17759)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.DiffSharp")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible
+// to COM components.  If you need to access a type in this assembly from
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("99935eb6-c98f-4524-a8e2-94c8f6a0c8d9")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("0.7.7")]
+[assembly: AssemblyFileVersion("0.7.7.$WCREV$")]
Index: /branches/3040_VectorBasedGP/HeuristicLab.ExtLibs.sln
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.ExtLibs.sln	(revision 17758)
+++ /branches/3040_VectorBasedGP/HeuristicLab.ExtLibs.sln	(revision 17759)
@@ -91,4 +91,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "TensorFlowNet", "TensorFlowNet\TensorFlowNet.csproj", "{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.DiffSharp", "HeuristicLab.DiffSharp\HeuristicLab.DiffSharp.csproj", "{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}"
 EndProject
 Global
@@ -496,12 +498,12 @@
 		{44A10478-D290-43C2-9757-F08F5292FEA5}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{44A10478-D290-43C2-9757-F08F5292FEA5}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{44A10478-D290-43C2-9757-F08F5292FEA5}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{44A10478-D290-43C2-9757-F08F5292FEA5}.Debug|x64.Build.0 = Debug|Any CPU
+		{44A10478-D290-43C2-9757-F08F5292FEA5}.Debug|x64.ActiveCfg = Debug|x64
+		{44A10478-D290-43C2-9757-F08F5292FEA5}.Debug|x64.Build.0 = Debug|x64
 		{44A10478-D290-43C2-9757-F08F5292FEA5}.Debug|x86.ActiveCfg = Debug|Any CPU
 		{44A10478-D290-43C2-9757-F08F5292FEA5}.Debug|x86.Build.0 = Debug|Any CPU
 		{44A10478-D290-43C2-9757-F08F5292FEA5}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{44A10478-D290-43C2-9757-F08F5292FEA5}.Release|Any CPU.Build.0 = Release|Any CPU
-		{44A10478-D290-43C2-9757-F08F5292FEA5}.Release|x64.ActiveCfg = Release|Any CPU
-		{44A10478-D290-43C2-9757-F08F5292FEA5}.Release|x64.Build.0 = Release|Any CPU
+		{44A10478-D290-43C2-9757-F08F5292FEA5}.Release|x64.ActiveCfg = Release|x64
+		{44A10478-D290-43C2-9757-F08F5292FEA5}.Release|x64.Build.0 = Release|x64
 		{44A10478-D290-43C2-9757-F08F5292FEA5}.Release|x86.ActiveCfg = Release|Any CPU
 		{44A10478-D290-43C2-9757-F08F5292FEA5}.Release|x86.Build.0 = Release|Any CPU
@@ -544,38 +546,46 @@
 		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x64.Build.0 = Debug|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x64.ActiveCfg = Debug|x64
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x64.Build.0 = Debug|x64
 		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x86.ActiveCfg = Debug|Any CPU
 		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x86.Build.0 = Debug|Any CPU
 		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|Any CPU.Build.0 = Release|Any CPU
-		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x64.ActiveCfg = Release|Any CPU
-		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x64.Build.0 = Release|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x64.ActiveCfg = Release|x64
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x64.Build.0 = Release|x64
 		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x86.ActiveCfg = Release|Any CPU
 		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x86.Build.0 = Release|Any CPU
 		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Debug|x64.Build.0 = Debug|Any CPU
+		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Debug|x64.ActiveCfg = Debug|x64
+		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Debug|x64.Build.0 = Debug|x64
 		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Debug|x86.ActiveCfg = Debug|Any CPU
 		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Debug|x86.Build.0 = Debug|Any CPU
 		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Release|Any CPU.Build.0 = Release|Any CPU
-		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Release|x64.ActiveCfg = Release|Any CPU
-		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Release|x64.Build.0 = Release|Any CPU
+		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Release|x64.ActiveCfg = Release|x64
+		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Release|x64.Build.0 = Release|x64
 		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Release|x86.ActiveCfg = Release|Any CPU
 		{C2E26343-88C7-4288-938B-EEE7C2ABBDB6}.Release|x86.Build.0 = Release|Any CPU
 		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Debug|x64.Build.0 = Debug|Any CPU
+		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Debug|x64.ActiveCfg = Debug|x64
+		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Debug|x64.Build.0 = Debug|x64
 		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Debug|x86.ActiveCfg = Debug|Any CPU
 		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Debug|x86.Build.0 = Debug|Any CPU
 		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Release|Any CPU.Build.0 = Release|Any CPU
-		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Release|x64.ActiveCfg = Release|Any CPU
-		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Release|x64.Build.0 = Release|Any CPU
+		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Release|x64.ActiveCfg = Release|x64
+		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Release|x64.Build.0 = Release|x64
 		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Release|x86.ActiveCfg = Release|Any CPU
 		{99BF44AE-436E-4B30-9435-E2BA98EE6FB3}.Release|x86.Build.0 = Release|Any CPU
+		{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}.Debug|Any CPU.ActiveCfg = Debug|x64
+		{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}.Debug|x64.ActiveCfg = Debug|x64
+		{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}.Debug|x64.Build.0 = Debug|x64
+		{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}.Debug|x86.ActiveCfg = Debug|x64
+		{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}.Release|Any CPU.ActiveCfg = Release|x64
+		{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}.Release|x64.ActiveCfg = Release|x64
+		{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}.Release|x64.Build.0 = Release|x64
+		{99935EB6-C98F-4524-A8E2-94C8F6A0C8D9}.Release|x86.ActiveCfg = Release|x64
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /branches/3040_VectorBasedGP/HeuristicLab.ExtLibs/HeuristicLab.Attic/1.0.0/HeuristicLab.Attic.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.ExtLibs/HeuristicLab.Attic/1.0.0/HeuristicLab.Attic.csproj	(revision 17758)
+++ /branches/3040_VectorBasedGP/HeuristicLab.ExtLibs/HeuristicLab.Attic/1.0.0/HeuristicLab.Attic.csproj	(revision 17759)
@@ -35,5 +35,27 @@
     <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HEAL.Attic, Version=1.5.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\bin\HEAL.Attic.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core" />
@@ -60,9 +82,4 @@
   </ItemGroup>
   <ItemGroup>
-    <PackageReference Include="HEAL.Attic">
-      <Version>1.5.0</Version>
-    </PackageReference>
-  </ItemGroup>
-  <ItemGroup>
     <ProjectReference Include="..\..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
       <Project>{94186a6a-5176-4402-ae83-886557b53cca}</Project>
@@ -73,4 +90,5 @@
       <Project>{44b10478-d290-43d3-9757-c08f5292fea5}</Project>
       <Name>HeuristicLab.Protobuf</Name>
+      <Private>False</Private>
     </ProjectReference>
   </ItemGroup>
Index: /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/HeuristicLab.MathNet.Numerics.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/HeuristicLab.MathNet.Numerics.csproj	(revision 17758)
+++ /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/HeuristicLab.MathNet.Numerics.csproj	(revision 17759)
@@ -31,7 +31,30 @@
     <WarningLevel>4</WarningLevel>
   </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>..\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HEAL.Attic, Version=1.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
+    <Reference Include="HEAL.Attic">
       <HintPath>..\bin\HEAL.Attic.dll</HintPath>
     </Reference>
@@ -42,4 +65,5 @@
   <ItemGroup>
     <Compile Include="VectorTransformer.cs" />
+    <None Include="HeuristicLab.snk" />
     <None Include="Plugin.cs.frame" />
     <Compile Include="Plugin.cs" />
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17758)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17759)
@@ -24,5 +24,5 @@
     <WarningLevel>4</WarningLevel>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>7.0</LangVersion>
+    <LangVersion>default</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -34,5 +34,5 @@
     <WarningLevel>4</WarningLevel>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>7.0</LangVersion>
+    <LangVersion>default</LangVersion>
   </PropertyGroup>
   <PropertyGroup>
@@ -56,5 +56,5 @@
     <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>5</LangVersion>
+    <LangVersion>default</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
@@ -74,5 +74,5 @@
     <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>5</LangVersion>
+    <LangVersion>default</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
@@ -90,5 +90,5 @@
     <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>5</LangVersion>
+    <LangVersion>default</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
@@ -108,5 +108,5 @@
     <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>5</LangVersion>
+    <LangVersion>default</LangVersion>
   </PropertyGroup>
   <ItemGroup>
Index: /branches/3040_VectorBasedGP/HeuristicLab.TensorFlowNet/HeuristicLab.TensorFlowNet.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.TensorFlowNet/HeuristicLab.TensorFlowNet.csproj	(revision 17758)
+++ /branches/3040_VectorBasedGP/HeuristicLab.TensorFlowNet/HeuristicLab.TensorFlowNet.csproj	(revision 17759)
@@ -33,4 +33,22 @@
   <PropertyGroup>
     <RunPostBuildEvent>OnBuildSuccess</RunPostBuildEvent>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>..\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
   </PropertyGroup>
   <ItemGroup>
Index: /branches/3040_VectorBasedGP/HeuristicLab/3.3/HeuristicLab-3.3.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 17758)
+++ /branches/3040_VectorBasedGP/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 17759)
@@ -192,4 +192,9 @@
     </BootstrapperPackage>
   </ItemGroup>
+  <ItemGroup>
+    <PackageReference Include="Google.Protobuf">
+      <Version>3.11.3</Version>
+    </PackageReference>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: /branches/3040_VectorBasedGP/HeuristicLab/3.3/app.config
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab/3.3/app.config	(revision 17758)
+++ /branches/3040_VectorBasedGP/HeuristicLab/3.3/app.config	(revision 17759)
@@ -9,4 +9,10 @@
   <runtime>
     <gcServer enabled="true"/>
+    <assemblyBinding xmlns="urn:schemas-microsoft-com:asm.v1">
+      <dependentAssembly>
+        <assemblyIdentity name="FSharp.Core" publicKeyToken="b03f5f7f11d50a3a" culture="neutral" />
+        <bindingRedirect oldVersion="0.0.0.0-4.7.0.0" newVersion="4.7.0.0" />
+      </dependentAssembly>
+    </assemblyBinding>
   </runtime>
 
Index: /branches/3040_VectorBasedGP/TensorFlowNet/TensorFlowNet.csproj
===================================================================
--- /branches/3040_VectorBasedGP/TensorFlowNet/TensorFlowNet.csproj	(revision 17758)
+++ /branches/3040_VectorBasedGP/TensorFlowNet/TensorFlowNet.csproj	(revision 17759)
@@ -30,4 +30,22 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>..\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
   </PropertyGroup>
   <ItemGroup>